Subject: [PATCH] [FEAT LS1212] zipl: Re-write boot loaders in C
From: Stefan Haberland <stefan.haberland@de.ibm.com>

Summary:     zipl: Re-write boot loaders in C
Description: Convert the zipl bootloader and dumper from assembler to
             C programming language for better serviceability.
Upstream-ID: -
Problem-ID:  LS1212

Signed-off-by: Stefan Haberland <stefan.haberland@de.ibm.com>
---
 common.mak                         |   18 
 include/util_part.h                |   17 
 include/util_proc.h                |   35 +
 libutil/util_part.c                |  284 ++++++++++++
 libutil/util_proc.c                |  394 ++++++++++++++++
 zipl/boot/Makefile                 |   99 ++--
 zipl/boot/cio.c                    |  273 +++++++++++
 zipl/boot/cio.h                    |  145 ++++++
 zipl/boot/common.S                 |  381 ----------------
 zipl/boot/eckd.h                   |   42 +
 zipl/boot/eckd0.S                  |   21 
 zipl/boot/eckd0_cdl.S              |   20 
 zipl/boot/eckd0_ldl.S              |   21 
 zipl/boot/eckd1.S                  |   65 +-
 zipl/boot/eckd1a.S                 |   79 ---
 zipl/boot/eckd1b.S                 |  209 +++++++-
 zipl/boot/eckd2.S                  |  124 -----
 zipl/boot/eckd2.c                  |   97 ++++
 zipl/boot/eckd2dump.S              |  767 --------------------------------
 zipl/boot/eckd2dump.c              |  200 ++++++++
 zipl/boot/eckd2dump.h              |   49 ++
 zipl/boot/eckd2dump_mv.c           |  206 ++++++++
 zipl/boot/eckd2dump_sv.c           |   83 +++
 zipl/boot/eckd2mvdump.S            |  594 -------------------------
 zipl/boot/entry.S                  |   18 
 zipl/boot/error.h                  |   68 ++
 zipl/boot/fba.h                    |   56 ++
 zipl/boot/fba0.S                   |   99 +---
 zipl/boot/fba1b.S                  |   90 +++
 zipl/boot/fba2.S                   |  129 -----
 zipl/boot/fba2.c                   |  122 +++++
 zipl/boot/fba2dump.S               |  556 -----------------------
 zipl/boot/fba2dump.c               |  186 +++++++
 zipl/boot/head.S                   |   27 +
 zipl/boot/kdump.c                  |   37 +
 zipl/boot/kdump.h                  |   43 +
 zipl/boot/kdump2.c                 |   46 +
 zipl/boot/kdump3.c                 |  108 ++++
 zipl/boot/libc.c                   |  380 ++++++++++++++++
 zipl/boot/libc.h                   |  103 ++++
 zipl/boot/menu.c                   |  194 ++++++++
 zipl/boot/menu.h                   |   41 +
 zipl/boot/s390.h                   |  374 +++++++++++++++
 zipl/boot/sclp.S                   |  675 ----------------------------
 zipl/boot/sclp.c                   |  361 +++++++++++++++
 zipl/boot/sclp.h                   |  156 ++++++
 zipl/boot/sclp_stage3.c            |  163 ++++++
 zipl/boot/sclp_stage3.h            |   52 ++
 zipl/boot/stage2.c                 |  137 +++++
 zipl/boot/stage2.h                 |   76 +++
 zipl/boot/stage2.lds               |   61 ++
 zipl/boot/stage2dump.c             |  300 ++++++++++++
 zipl/boot/stage2dump.h             |  127 +++++
 zipl/boot/stage3.S                 |  198 --------
 zipl/boot/stage3.c                 |  298 ++++++++++++
 zipl/boot/stage3.h                 |   38 +
 zipl/boot/stage3.lds               |   45 +
 zipl/boot/tape0.S                  |   22 
 zipl/boot/tape2dump.c              |  214 +++++++++
 zipl/boot/tapedump.S               |  875 -------------------------------------
 zipl/include/boot.h                |  249 ++++++++--
 zipl/include/bootmap.h             |    1 
 zipl/include/disk.h                |   11 
 zipl/include/install.h             |   10 
 zipl/include/job.h                 |   29 -
 zipl/include/misc.h                |    9 
 zipl/include/proc.h                |   37 -
 zipl/include/scan.h                |    3 
 zipl/include/zipl.h                |   16 
 zipl/man/zipl.8                    |   62 +-
 zipl/man/zipl.conf.5               |   46 -
 zipl/src/Makefile                  |   22 
 zipl/src/boot.c                    |  369 ++++++---------
 zipl/src/bootmap.c                 |  434 +++++++++---------
 zipl/src/disk.c                    |  286 +++++++++---
 zipl/src/install.c                 |  722 ++++++++++++++----------------
 zipl/src/job.c                     |  209 +++-----
 zipl/src/misc.c                    |  169 +++++++
 zipl/src/proc.c                    |  331 -------------
 zipl/src/scan.c                    |   34 -
 zipl/src/zipl.c                    |   52 +-
 zipl/src/zipl_helper.device-mapper |   46 +
 82 files changed, 7727 insertions(+), 6118 deletions(-)

--- a/common.mak
+++ b/common.mak
@@ -101,6 +101,24 @@ export AS LD CC CPP AR NM STRIP OBJCOPY
 
 all:
 
+# rules for shared files
+# needed to ensure that these files are build with their own build
+# flags even if they are build from external directories
+$(rootdir)/libutil/util_part.o:
+	make -C $(rootdir)/libutil/ util_part.o
+
+$(rootdir)/libutil/util_list.o:
+	make -C $(rootdir)/libutil/ util_list.o
+
+$(rootdir)/libutil/util_proc.o:
+	make -C $(rootdir)/libutil/ util_proc.o
+
+$(rootdir)/libvtoc/vtoc.o:
+	make -C $(rootdir)/libvtoc/ vtoc.o
+
+$(rootdir)/zipl/boot/data.o:
+	make -C $(rootdir)/zipl/boot/ data.o
+
 install_dirs:
 	for dir in $(INSTDIRS); do \
 		test -d $$dir || $(INSTALL) -g $(GROUP) -o $(OWNER) -d $$dir; \
--- /dev/null
+++ b/include/util_part.h
@@ -0,0 +1,17 @@
+/*
+ * util - Utility function library
+ *
+ * Partition detection functions
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+#ifndef UTIL_PART_H
+#define UTIL_PART_H
+
+int util_part_search(const char *dev, size_t blk_start, size_t blk_cnt,
+		     size_t blk_size, int *ext_part);
+int util_part_search_fh(int fh, size_t blk_start, size_t blk_cnt,
+			size_t blk_size, int *ext_part);
+
+#endif /* UTIL_PART_H */
--- /dev/null
+++ b/include/util_proc.h
@@ -0,0 +1,35 @@
+/*
+ *   Scanner for the /proc files
+ *
+ * Copyright IBM Corp. 2001, 2007.
+ *
+ * Author(s): Peter Oberparleiter <Peter.Oberparleiter@de.ibm.com>
+ */
+
+#ifndef PROC_H
+#define PROC_H
+
+#include <ctype.h>
+#include <sys/types.h>
+
+
+struct util_proc_part_entry {
+	dev_t device;
+	size_t blockcount;
+	char *name;
+};
+
+struct util_proc_dev_entry {
+	int blockdev;
+	dev_t device;
+	char *name;
+};
+
+
+int util_proc_part_get_entry(dev_t device, struct util_proc_part_entry *entry);
+void util_proc_part_free_entry(struct util_proc_part_entry *entry);
+int util_proc_dev_get_entry(dev_t dev, int blockdev,
+			    struct util_proc_dev_entry *entry);
+void util_proc_dev_free_entry(struct util_proc_dev_entry *entry);
+
+#endif /* not PROC_H */
--- /dev/null
+++ b/libutil/util_part.c
@@ -0,0 +1,284 @@
+/*
+ * util - Utility function library
+ *
+ * Partition detection functions
+ *
+ * Copyright IBM Corp. 2013
+ */
+
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <endian.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include "util.h"
+
+#define GPT_SIGNATURE		0x4546492050415254ULL /* EFI PART */
+#define MBR_SIGNATURE		0x55aa
+#define MBR_PART_TYPE_DOS_EXT	0x05 /* DOS extended partition */
+#define MBR_PART_TYPE_WIN98_EXT	0x0f /* Windows 98 extended partition */
+#define MBR_PART_TYPE_LINUX_EXT	0x85 /* Linux extended partition */
+#define MBR_PART_TYPE_GPT	0xee /* GPT partition */
+#define MBR_EXT_PART_NUM_FIRST	5 /* Partition number for first logical vol */
+
+/*
+ * MBR/MSDOS partition entry
+ */
+struct mbr_part_entry {
+	uint8_t status;
+	uint8_t chs_start[3];
+	uint8_t type;
+	uint8_t chs_end[3];
+	uint32_t blk_start;
+	uint32_t blk_cnt;
+} __attribute__((packed));
+
+/*
+ * Master Boot Record (MBR)
+ */
+struct mbr {
+	uint8_t reserved[0x1be];
+	struct mbr_part_entry part_entry_vec[4];
+	uint16_t signature;
+} __attribute__((packed));
+
+/*
+ * GUID Partition Table (GPT) header
+ */
+struct gpt {
+	uint64_t signature;
+	uint32_t version;
+	uint32_t hdr_size;
+	uint32_t hdr_crc;
+	uint32_t reserved1;
+	uint64_t blk_cur;
+	uint64_t blk_back;
+	uint64_t blk_first;
+	uint64_t blk_last;
+	uint8_t guid[16];
+	uint64_t part_tab_blk_start;
+	uint32_t part_tab_cnt;
+	uint32_t part_tab_entry_size;
+	uint32_t part_tab_crc;
+} __attribute__((packed));
+
+/*
+ * GPT partition entry
+ */
+struct gpt_part_entry {
+	uint8_t type[16];
+	uint8_t guid[16];
+	uint64_t blk_start;
+	uint64_t blk_end;
+	uint64_t attr;
+	char name[72];
+} __attribute__((packed));
+
+/*
+ * Check for extended partition
+ */
+static int mbr_part_is_ext(uint8_t type)
+{
+	if ((type == MBR_PART_TYPE_DOS_EXT) ||
+	    (type == MBR_PART_TYPE_WIN98_EXT) ||
+	    (type == MBR_PART_TYPE_LINUX_EXT))
+		return 1;
+	return 0;
+}
+
+/*
+ * Check if disk has a classic MBR partion table
+ */
+static int mbr_table_valid(struct mbr *mbr)
+{
+	return mbr->signature == MBR_SIGNATURE;
+}
+
+/*
+ * Search partition in logical volumes of an extended partition
+ */
+static int mbr_table_ext_search(int fh, size_t blk_start_mbr,
+				size_t blk_start, size_t blk_cnt,
+				size_t blk_size, int part_num)
+{
+	size_t start, cnt, start_next;
+	struct mbr mbr;
+
+	/* Read MBR for logical volume */
+	if (lseek(fh, blk_start_mbr * blk_size, SEEK_SET) == (off_t)-1)
+		return -1;
+	if (read(fh, &mbr, sizeof(mbr)) == -1)
+		return -1;
+
+	/* Check for invalid MBR or last entry */
+	if (mbr.signature != MBR_SIGNATURE)
+		return -1;
+	if (mbr.part_entry_vec[0].blk_start == 0)
+		return -1;
+
+	/* First entry contains a relative offset for current logical volume */
+	start = blk_start_mbr + le32toh(mbr.part_entry_vec[0].blk_start);
+	cnt = le32toh(mbr.part_entry_vec[0].blk_cnt);
+
+	if ((start == blk_start) && (cnt == blk_cnt))
+		return part_num;
+
+	/* Second entry contains relative offset for next logical volume */
+	start_next = le32toh(mbr.part_entry_vec[1].blk_start);
+	if (start_next == 0)
+		return 0;
+	start_next += blk_start_mbr;
+
+	/* Recursively search for next logical volume in chain */
+	return mbr_table_ext_search(fh, start_next, blk_start, blk_cnt,
+				    blk_size, part_num + 1);
+}
+
+/*
+ * Search partition in MBR partition table
+ */
+static int mbr_table_search(int fh, struct mbr *mbr, size_t blk_start,
+			    size_t blk_cnt, size_t blk_size, int *part_ext)
+{
+	int part_num_ext, part_num;
+	size_t start, cnt;
+	uint8_t type;
+
+	for (part_num = 1; part_num <= 4; part_num++) {
+		type = mbr->part_entry_vec[part_num - 1].type;
+		start = le32toh(mbr->part_entry_vec[part_num - 1].blk_start);
+		cnt = le32toh(mbr->part_entry_vec[part_num - 1].blk_cnt);
+		if (start == 0) /* Empty slot */
+			continue;
+		/*
+		 * The kernel sets count for extended partitions explicitly.
+		 * Therefore we do not check count here.
+		 */
+		if (mbr_part_is_ext(type) && (start == blk_start)) {
+			*part_ext = 1;
+			return part_num;
+		}
+		if ((start == blk_start) && (cnt == blk_cnt))
+			return part_num;
+		if (!mbr_part_is_ext(type))
+			continue;
+		part_num_ext = mbr_table_ext_search(fh, start, blk_start,
+						    blk_cnt, blk_size,
+						    MBR_EXT_PART_NUM_FIRST);
+		if (part_num_ext != 0)
+			return part_num_ext;
+	}
+	return 0;
+}
+
+/*
+ * Search partition in GPT partition table
+ */
+static int gpt_table_search(int fh, struct gpt *gpt, size_t blk_start,
+			    size_t blk_cnt, size_t blk_size)
+{
+	size_t start, end, part_tab_blk_start, blk_end;
+	uint32_t part_tab_cnt, part_tab_entry_size;
+	struct gpt_part_entry *part_entry;
+	unsigned int part_num;
+
+	blk_end = blk_start + blk_cnt - 1;
+	part_tab_entry_size = le32toh(gpt->part_tab_entry_size);
+	part_tab_cnt = le32toh(gpt->part_tab_cnt);
+	part_tab_blk_start = le64toh(gpt->part_tab_blk_start);
+
+	if (lseek(fh, part_tab_blk_start * blk_size, SEEK_SET) == (off_t)-1)
+		return -1;
+	for (part_num = 1; part_num <= part_tab_cnt; part_num++) {
+		char buf[part_tab_entry_size];
+
+		part_entry = (struct gpt_part_entry *) buf;
+		if (read(fh, buf, sizeof(buf)) == -1)
+			return -1;
+		start = le64toh(part_entry->blk_start);
+		end = le64toh(part_entry->blk_end);
+		if (start == 0) /* Empty slot */
+			continue;
+		if ((start == blk_start) && (end == blk_end))
+			return part_num;
+	}
+	return 0;
+}
+
+/*
+ * Check if disk has a GPT partition table
+ */
+static int gpt_table_valid(struct gpt *gpt, struct mbr *mbr)
+{
+	int cnt, part_num;
+	uint32_t start;
+	uint8_t type;
+
+	if (gpt->signature != GPT_SIGNATURE)
+		return 0;
+
+	/* Check for protective MBR (one reserved GPT partition) */
+	for (part_num = 1, cnt = 0; part_num <= 4; part_num++) {
+		start = le32toh(mbr->part_entry_vec[part_num - 1].blk_start);
+		type = mbr->part_entry_vec[part_num - 1].type;
+		if (!start)
+			continue;
+		if (type != MBR_PART_TYPE_GPT)
+			return 0;
+		if (++cnt > 1)
+			return 0;
+	}
+	return 1;
+}
+
+/*
+ * Search for partition with given start block and count
+ *
+ * Return partition number when found, 0 when not found, and on error -1
+ * Set "part_ext" to 1 for extended partitions otherwise to 0.
+ */
+int util_part_search_fh(int fh, size_t blk_start, size_t blk_cnt,
+			size_t blk_size, int *part_ext)
+{
+	struct gpt gpt;
+	struct mbr mbr;
+
+	if (lseek(fh, 0, SEEK_SET) == (off_t)-1)
+		return -1;
+	if (read(fh, &mbr, sizeof(mbr)) == -1)
+		return -1;
+	if (lseek(fh, blk_size, SEEK_SET) == (off_t)-1)
+		return -1;
+	if (read(fh, &gpt, sizeof(gpt)) == -1)
+		return -1;
+	*part_ext = 0;
+	if (gpt_table_valid(&gpt, &mbr))
+		return gpt_table_search(fh, &gpt, blk_start, blk_cnt, blk_size);
+	if (mbr_table_valid(&mbr))
+		return mbr_table_search(fh, &mbr, blk_start, blk_cnt, blk_size,
+					part_ext);
+	return -1;
+}
+
+/*
+ * Search for partition with given start block and count
+ *
+ * Return partition number when found, 0 when not found, and on error -1
+ * Set "part_ext" to 1 for extended partitions otherwise to 0.
+ */
+int util_part_search(const char *device, size_t blk_start, size_t blk_cnt,
+		     size_t blk_size, int *part_ext)
+{
+	int rc, fh;
+
+	fh = open(device, O_RDONLY);
+	if (fh == -1)
+		return -1;
+	rc = util_part_search_fh(fh, blk_start, blk_cnt, blk_size, part_ext);
+	close(fh);
+	return rc;
+}
--- /dev/null
+++ b/libutil/util_proc.c
@@ -0,0 +1,394 @@
+/*
+ * s390-tools/zipl/src/proc.c
+ *   Scanner for the /proc/ files
+ *
+ * Copyright IBM Corp. 2001, 2007.
+ *
+ * Author(s): Peter Oberparleiter <Peter.Oberparleiter@de.ibm.com>
+ */
+
+#include "util_proc.h"
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/sysmacros.h>
+
+static const char util_proc_part_filename[] = "/proc/partitions";
+static const char util_proc_dev_filename[] = "/proc/devices";
+
+struct file_buffer {
+	char *buffer;
+	off_t pos;
+	size_t length;
+};
+
+#define INITIAL_FILE_BUFFER_SIZE	1024
+
+/* Read file into buffer without querying its size (necessary for reading files
+ * from /proc). Upon success, return zero and set BUFFER to point to
+ * the file buffer and SIZE (if non-null) to contain the file size. Return
+ * non-zero otherwise. Add a null-byte at the end of the buffer if
+ * NIL_TERMINATE is non-zero.  */
+static int
+util_proc_read_special_file(const char *filename, char **buffer, size_t *size,
+		       int nil_terminate)
+{
+	FILE *file;
+	char *data;
+	char *new_data;
+	size_t count;
+	size_t current_size;
+	int current;
+
+	file = fopen(filename, "r");
+	if (file == NULL) {
+		printf("Could not open %s\n",
+		       filename);
+		return -1;
+	}
+	current_size = INITIAL_FILE_BUFFER_SIZE;
+	count = 0;
+	data = (char *) malloc(current_size);
+	if (data == NULL) {
+		printf("Could not allocate %lld bytes of memory",
+		       (unsigned long long) size);
+		fclose(file);
+		return -1;
+	}
+	current = fgetc(file);
+	while (current != EOF || nil_terminate) {
+		if (current == EOF) {
+			current = 0;
+			nil_terminate = 0;
+		}
+		data[count++] = (char) current;
+		if (count >= current_size) {
+			new_data = (char *) malloc(current_size * 2);
+			if (new_data == NULL) {
+				printf("Could not allocate %lld bytes of memory",
+				       (unsigned long long) size);
+				free(data);
+				fclose(file);
+				return -1;
+			}
+			memcpy(new_data, data, current_size);
+			free(data);
+			data = new_data;
+			current_size *= 2;
+		}
+		current = fgetc(file);
+	}
+	fclose(file);
+	*buffer = data;
+	if (size)
+		*size = count;
+	return 0;
+}
+
+/* Get the contents of a file and fill in the respective fields of
+ * FILE. Return 0 on success, non-zero otherwise. */
+static int
+get_file_buffer(struct file_buffer *file, const char *filename)
+{
+	int rc;
+
+	rc = util_proc_read_special_file(filename, &file->buffer,
+					 &file->length, 0);
+	file->pos = 0;
+	return rc;
+}
+
+
+/* Free resources allocated for file buffer identified by
+ * FILE. */
+static void
+free_file_buffer(struct file_buffer *file)
+{
+	if (file->buffer != NULL) {
+		free(file->buffer);
+		file->buffer = NULL;
+		file->pos = 0;
+		file->length = 0;
+	}
+}
+
+
+/* Return character at current FILE buffer position or EOF if at end of
+ * file. */
+static int
+current_char(struct file_buffer *file)
+{
+	if (file->buffer != NULL)
+		if (file->pos < (off_t) file->length)
+			return file->buffer[file->pos];
+	return EOF;
+}
+
+
+/* Advance the current file pointer of file buffer FILE until the current
+ * character is no longer a whitespace or until the end of line or file is
+ * reached. Return 0 if at least one whitespace character was encountered,
+ * non-zero otherwise. */
+static int
+skip_whitespaces(struct file_buffer *file)
+{
+	int rc;
+
+	rc = -1;
+	while ((current_char(file) != '\n') && isspace(current_char(file))) {
+		rc = 0;
+		file->pos++;
+	}
+	return rc;
+}
+
+
+/* Scan a positive integer number at the current position of file buffer FILE
+ * and advance the position respectively. Upon success, return zero and set
+ * NUMBER to contain the scanned number. Return non-zero otherwise. */
+static int
+scan_number(struct file_buffer *file, size_t *number)
+{
+	int rc;
+	size_t old_number;
+
+	*number = 0;
+	rc = -1;
+	while (isdigit(current_char(file))) {
+		rc = 0;
+		old_number = *number;
+		*number = *number * 10 + current_char(file) - '0';
+		/* Check for overflow */
+		if (old_number > *number) {
+			rc = -1;
+			break;
+		}
+		file->pos++;
+	}
+	return rc;
+}
+
+
+/* Scan a device node name at the current position of file buffer FILE and
+ * advance the position respectively. Upon success, return zero and set
+ * NAME to contain a copy of the scanned name. Return non-zero otherwise. */
+static int
+scan_name(struct file_buffer *file, char **name)
+{
+	off_t start_pos;
+
+	start_pos = file->pos;
+	while (!isspace(current_char(file)) &&
+	       (current_char(file) != EOF))
+			file->pos++;
+	if (file->pos > start_pos) {
+		*name = (char *) malloc(file->pos - start_pos + 1);
+		if (*name == NULL)
+			return -1;
+		memcpy((void *) *name, (void *) &file->buffer[start_pos],
+		       file->pos - start_pos);
+		(*name)[file->pos - start_pos] = 0;
+		return 0;
+	} else
+		return -1;
+}
+
+/* Scan for the specified STRING at the current position of file buffer FILE
+ * and advance the position respectively. Upon success, return zero. Return
+ * non-zero otherwise. */
+static int
+scan_string(struct file_buffer *file, const char *string)
+{
+	int i;
+
+	i = 0;
+	for (i = 0; string[i] && (current_char(file) == string[i]);
+	     i++, file->pos++)
+		;
+	if (string[i] == '\0')
+		return 0;
+	return -1;
+}
+
+
+/* Advance the current file position to beginning of next line in file buffer
+ * FILE or to end of file. */
+static void
+skip_line(struct file_buffer *file)
+{
+	while ((current_char(file) != '\n') && (current_char(file) != EOF))
+		file->pos++;
+	if (current_char(file) == '\n')
+		file->pos++;
+}
+
+
+/* Return non-zero if the current file position of file buffer FILE is at the
+ * end of file. Return zero otherwise. */
+static int
+eof(struct file_buffer *file)
+{
+	return file->pos >= (off_t) file->length;
+}
+
+
+/* Scan a line of the specified /proc/partitions FILE buffer and advance the
+ * current file position pointer respectively. If the current line matches
+ * the correct pattern, fill in the corresponding data into ENTRY and return 0.
+ * Return non-zero otherwise. */
+static int
+scan_part_entry(struct file_buffer *file, struct util_proc_part_entry *entry)
+{
+	int rc;
+	size_t dev_major;
+	size_t dev_minor;
+	size_t blockcount;
+	char *name;
+
+	/* Scan for: (\s*)(\d+)(\s+)(\d+)(\s+)(\d+)(\s+)(\S+)(\.*)$ */
+	skip_whitespaces(file);
+	rc = scan_number(file, &dev_major);
+	if (rc)
+		return rc;
+	rc = skip_whitespaces(file);
+	if (rc)
+		return rc;
+	rc = scan_number(file, &dev_minor);
+	if (rc)
+		return rc;
+	rc = skip_whitespaces(file);
+	if (rc)
+		return rc;
+	rc = scan_number(file, &blockcount);
+	if (rc)
+		return rc;
+	rc = skip_whitespaces(file);
+	if (rc)
+		return rc;
+	rc = scan_name(file, &name);
+	if (rc)
+		return rc;
+	skip_line(file);
+	entry->device = makedev(dev_major, dev_minor);
+	entry->blockcount = blockcount;
+	entry->name = name;
+	return 0;
+}
+
+
+/* Release resources associated with ENTRY. */
+void
+util_proc_part_free_entry(struct util_proc_part_entry *entry)
+{
+	if (entry->name != NULL) {
+		free(entry->name);
+		entry->name = NULL;
+	}
+}
+
+/* Scan a line of the specified /proc/devices FILE buffer and advance the
+ * current file position pointer respectively. If the current line matches
+ * the correct pattern, fill in the corresponding data into ENTRY and return 0.
+ * Return non-zero otherwise. */
+static int
+scan_dev_entry(struct file_buffer *file, struct util_proc_dev_entry *entry,
+	       int blockdev)
+{
+	int rc;
+	size_t dev_major;
+	char *name;
+
+	/* Scan for: (\s*)(\d+)(\s+)(\S+)(\.*)$ */
+	skip_whitespaces(file);
+	rc = scan_number(file, &dev_major);
+	if (rc)
+		return rc;
+	rc = skip_whitespaces(file);
+	if (rc)
+		return rc;
+	rc = scan_name(file, &name);
+	if (rc)
+		return rc;
+	skip_line(file);
+	entry->device = makedev(dev_major, 0);
+	entry->name = name;
+	entry->blockdev = blockdev;
+	return 0;
+}
+
+
+/* Release resources associated with ENTRY. */
+void
+util_proc_dev_free_entry(struct util_proc_dev_entry *entry)
+{
+	if (entry->name != NULL) {
+		free(entry->name);
+		entry->name = NULL;
+	}
+}
+
+
+/* Scan /proc/partitions for an entry matching DEVICE. When there is a match,
+ * store entry data in ENTRY and return 0. Return non-zero otherwise. */
+int
+util_proc_part_get_entry(dev_t device, struct util_proc_part_entry *entry)
+{
+	struct file_buffer file;
+	int rc;
+
+	rc = get_file_buffer(&file, util_proc_part_filename);
+	if (rc)
+		return rc;
+	rc = -1;
+	while (!eof(&file)) {
+		if (scan_part_entry(&file, entry) == 0) {
+			if (entry->device == device) {
+				rc = 0;
+				break;
+			}
+			util_proc_part_free_entry(entry);
+		} else
+			skip_line(&file);
+	}
+	free_file_buffer(&file);
+	return rc;
+}
+
+/* Scan /proc/devices for a blockdevice (BLOCKDEV is 1) or a character
+ * device (BLOCKDEV is 0) with a major number matching the major number of DEV.
+ * When there is a match, store entry data in ENTRY and return 0. Return
+ * non-zero otherwise. */
+int
+util_proc_dev_get_entry(dev_t device, int blockdev,
+			struct util_proc_dev_entry *entry)
+{
+	struct file_buffer file;
+	int rc;
+	int scan_blockdev = 0;
+
+	rc = get_file_buffer(&file, util_proc_dev_filename);
+	if (rc)
+		return rc;
+	rc = -1;
+	while (!eof(&file)) {
+		if (scan_string(&file, "Block") == 0) {
+			skip_line(&file);
+			scan_blockdev = 1;
+			continue;
+		} else if (scan_dev_entry(&file, entry, scan_blockdev) == 0) {
+			if ((major(entry->device) == major(device)) &&
+			    blockdev == scan_blockdev) {
+				rc = 0;
+				break;
+			}
+			util_proc_dev_free_entry(entry);
+		} else
+			skip_line(&file);
+	}
+	free_file_buffer(&file);
+	return rc;
+}
--- a/zipl/boot/Makefile
+++ b/zipl/boot/Makefile
@@ -1,14 +1,26 @@
 # Common definitions
 include ../../common.mak
 
-S390_TOOLS_VERSION_EBCDIC := $(shell echo -n $(S390_TOOLS_RELEASE) | dd conv=ebcdic 2> /dev/null | hexdump -v -e '/1 "0x%02x,"' | sed 's/.$$//')
+CFLAGS	= -Os -g -I../include -D__ASSEMBLY__ \
+	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
+	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
+	  -fno-delete-null-pointer-checks -fno-strict-aliasing \
+	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
+	  -mstack-size=8192 -mstack-guard=128 -msoft-float $(WARNFLAGS)
+
+FILES	= fba0.bin fba1b.bin fba2.bin \
+	  eckd0_ldl.bin eckd0_cdl.bin \
+	  eckd1.bin eckd1b.bin eckd2.bin \
+	  tape0.bin \
+	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin \
+	  stage3.bin
 
-CFLAGS  += -I../include -D__ASSEMBLY__ \
-		-DS390_TOOLS_VERSION_EBCDIC=$(S390_TOOLS_VERSION_EBCDIC)
-LDFLAGS = -O2
-FILES	:= fba0.bin fba2.bin eckd0.bin eckd1a.bin eckd1b.bin eckd2.bin \
-	   eckd2dump.bin tapedump.bin stage3.bin tape0.bin fba2dump.bin \
-	   eckd2mvdump.bin
+HEADERS	= cio.h eckd2dump.h fba.h libc.h s390.h sclp_stage3.h stage2dump.h \
+	  eckd.h error.h kdump.h menu.h sclp.h stage2.h stage3.h
+
+*.o: $(HEADERS)
+
+eckd2dump.o: cio.h
 
 all: data.o data.h tape0.bin
 
@@ -18,26 +30,54 @@ all: data.o data.h tape0.bin
 %.o:	%.S
 	$(CC) $(CFLAGS) -c -o $@ $<
 
+eckd2dump_sv.exec: \
+	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
+	libc.o sclp.o entry.o
+eckd2dump_mv.exec: \
+	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
+	libc.o sclp.o entry.o
+fba2dump.exec: \
+	head.o stage2dump.o cio.o fba2dump.o \
+	libc.o sclp.o entry.o
+tape2dump.exec: \
+	head.o stage2dump.o cio.o tape2dump.o \
+	libc.o sclp.o entry.o
+eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o menu.o sclp.o \
+	    kdump2.o kdump.o entry.o
+fba2.exec: head.o stage2.o cio.o fba2.o libc.o menu.o sclp.o \
+	   kdump2.o kdump.o entry.o
+stage3.exec: head.o stage3.o kdump3.o libc.o sclp.o sclp_stage3.o \
+	     kdump.o entry.o
+
 %.exec:	%.o
-	@STAGE=$$(                                  \
-		echo $@ | awk '                           \
-			match($$0,/[0-9]+/){                    \
-				print substr($$0,RSTART,RLENGTH)      \
-			}                                       \
-			/tapedump/{                             \
-				print "2"                             \
-			}'                                      \
-	);                                          \
-	case $$STAGE in                             \
-		0) SFLAGS="-nostdlib -Wl,-Ttext,0";;      \
-		1) SFLAGS="-nostdlib -Wl,-Ttext,0x218";;  \
-		2) SFLAGS="-nostdlib -Wl,-Ttext,0x2000";; \
-		3) SFLAGS="-nostdlib -Wl,-Ttext,0xA000";; \
-	esac;                                       \
-	$(LINK) $(LDFLAGS) $$SFLAGS $^ $(LOADLIBES) $(LDLIBS) -o $@
+	@STAGE=$$( \
+		echo $@ | awk ' \
+			match($$0,/[0-9]+b*/){ \
+				print substr($$0,RSTART,RLENGTH) \
+			}' \
+	); \
+	case $$STAGE in \
+		0) SFLAGS="-nostdlib -Wl,-Ttext,0";; \
+		1) SFLAGS="-nostdlib -Wl,-Ttext,0x18";; \
+		1b) SFLAGS="-nostdlib -Wl,-Ttext,0xE000";; \
+		2) SFLAGS="-nostdlib -Wl,-T,stage2.lds";; \
+		3) SFLAGS="-nostdlib -Wl,-T,stage3.lds";; \
+	esac; \
+	$(LINK) $$SFLAGS -m64 $^ -o $@
 
 %.bin:	%.exec
-	$(OBJCOPY) -O binary --only-section=.text $< $@
+	$(OBJCOPY) -O binary \
+		--only-section=.stage2.head \
+		--only-section=.text.dummy \
+		--only-section=.text.start \
+		--only-section=.text \
+		--only-section=.ex_table \
+		--only-section=.data \
+		--only-section=.rodata.str1.2 \
+		--only-section=.rodata \
+		--only-section=.stage2dump.tail \
+		--only-section=.eckd2dump_mv.tail \
+		$< $@
 
 data.o: $(FILES)
 	$(LD) -r -b binary -o data.o $(FILES)
@@ -48,15 +88,6 @@ data.h: data.o
 				echo "extern char $$SYMBOL;" >>data.h; done
 
 clean:
-	rm -f *.o *.exec *.bin $(FILES) data.o data.h tape0.bin
+	rm -f *.o *.exec *.bin $(FILES) data.o data.h tape0.bin *.xxx *.yyy
 
 .PHONY: all clean
-
-
-# Additional manual dependencies
-
-eckd2.o: common.S menu.S sclp.S
-fba2.o: common.S menu.S sclp.S
-eckd2dump.o: dumpcommon.S
-tapedump.o: dumpcommon.S
-eckd2mvdump.o: dumpcommon.S
